import timeit

from shyft.time_series import time, UtcPeriod
# notice that currently we need shyft imported prior to fm, (fix already in pipeline)
from statkraft import fame_api as fm
from statkraft.ssa.environment import FameEnvironment, FAME_PREPROD_HOST
from statkraft.ssa.wrappers import ReadWrapper

import config
import pyfame

names = ['MARGINAL_COST.ALHOLMA.FIN.EUR.MWH.H',
         'MARGINAL_COST.AMAGER1.DK2.EUR.MWH.H',
         'MARGINAL_COST.AMAGER3.DK2.EUR.MWH.H',
         'MARGINAL_COST.ASNAS2.DK2.EUR.MWH.H',
         'MARGINAL_COST.ASNAS4.DK2.EUR.MWH.H',
         'MARGINAL_COST.ASNAS5.DK2.EUR.MWH.H',
         'MARGINAL_COST.AVEDORE1.DK2.EUR.MWH.H',
         'MARGINAL_COST.AVEDORE2.DK2.EUR.MWH.H',
         'MARGINAL_COST.BORGUND_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.ENSTED3.DK1.EUR.MWH.H',
         'MARGINAL_COST.ESBJERG3.DK1.EUR.MWH.H',
         'MARGINAL_COST.FYN7.DK1.EUR.MWH.H',
         'MARGINAL_COST.HAAPAVESI.FIN.EUR.MWH.H',
         'MARGINAL_COST.HC_ORSTED1.DK2.EUR.MWH.H',
         'MARGINAL_COST.HC_ORSTED7.DK2.EUR.MWH.H',
         'MARGINAL_COST.INKOO1.FIN.EUR.MWH.H',
         'MARGINAL_COST.INKOO2.FIN.EUR.MWH.H',
         'MARGINAL_COST.INKOO3.FIN.EUR.MWH.H',
         'MARGINAL_COST.INKOO4.FIN.EUR.MWH.H',
         'MARGINAL_COST.KAARSTOE.NO2.EUR.MWH.H',
         'MARGINAL_COST.KARLSHAMN1.SE4.EUR.MWH.H',
         'MARGINAL_COST.KARLSHAMN2.SE4.EUR.MWH.H',
         'MARGINAL_COST.KARLSHAMN3.SE4.EUR.MWH.H',
         'MARGINAL_COST.KRISTINA1.FIN.EUR.MWH.H',
         'MARGINAL_COST.KRISTINA2.FIN.EUR.MWH.H',
         'MARGINAL_COST.KYNDBY1_2.DK2.EUR.MWH.H',
         'MARGINAL_COST.KYNDBY3.DK2.EUR.MWH.H',
         'MARGINAL_COST.MERIPORI.FIN.EUR.MWH.H',
         'MARGINAL_COST.MUSSALO1.FIN.EUR.MWH.H',
         'MARGINAL_COST.MUSSALO2.FIN.EUR.MWH.H',
         'MARGINAL_COST.NORDJYLL.DK1.EUR.MWH.H',
         'MARGINAL_COST.NORDJYLL2.DK1.EUR.MWH.H',
         'MARGINAL_COST.NORDJYLL3.DK1.EUR.MWH.H',
         'MARGINAL_COST.NYHAMNA1.NO3.EUR.MWH.H',
         'MARGINAL_COST.SKAERBAEK3.DK1.EUR.MWH.H',
         'MARGINAL_COST.STENUNGSUND3.SE3.EUR.MWH.H',
         'MARGINAL_COST.STENUNGSUND4.SE3.EUR.MWH.H',
         'MARGINAL_COST.STIGNES1.DK2.EUR.MWH.H',
         'MARGINAL_COST.STIGNES2.DK2.EUR.MWH.H',
         'MARGINAL_COST.STUDS3.DK1.EUR.MWH.H',
         'MARGINAL_COST.STUDS4.DK1.EUR.MWH.H',
         'MARGINAL_COST.SVANE7.DK2.EUR.MWH.H',
         'MARGINAL_COST.TAHKOLUOTO.FIN.EUR.MWH.H',
         'MARGINAL_COST.TJELDBERGODDEN1.NO3.EUR.MWH.H',
         'MARGINAL_COST.TYIN_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.VARTAN1.SE3.EUR.MWH.H',
         'MARGINAL_COST.VARTAN6.SE3.EUR.MWH.H',
         'MARGINAL_COST.VINSTRA_NEDRE_G5.NO1.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_A3.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_A4.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G3.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G4.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYLEN_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYLEN_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.AURA_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G3.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G4.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G5.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G6.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G7.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEA_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEA_G2.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEA_G3.NO3.EUR.MWH.H',
         'MARGINAL_COST.GRYTTEN_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.OSBU_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.GRASJO_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.TROLLHEIM_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.SVORKA_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEDALSFOSS_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.TYA_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.VESSINGFOSS_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.KJELA_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.SONGA_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.VINJE_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.VINJE_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.VINJE_G3.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G3.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G4.NO2.EUR.MWH.H',
         'MARGINAL_COST.BYRTE_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.LIO_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.JUKLA_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.MAURANGER_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.MAURANGER_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.TYSSO_2_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.TYSSO_2_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.OKSLA_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.MALSET_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.LEIRDOLA_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.JOSTEDAL_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.MAR_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G3.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G4.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G5.NO2.EUR.MWH.H',
         'MARGINAL_COST.RANA_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.RANA_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.RANA_G3.NO4.EUR.MWH.H',
         'MARGINAL_COST.RANA_G4.NO4.EUR.MWH.H',
         'MARGINAL_COST.BJERKA_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.SVARTISEN_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.KOBBELV_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.KOBBELV_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.BATSVATN_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.NORDDALEN_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.SKJOMEN_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.SKJOMEN_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SKJOMEN_G3.NO4.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G3.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G4.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G5.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G6.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G7.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G8.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_2_G1.NO1.EUR.MWH.H',
         'MARGINAL_COST.NORE_2_G2.NO1.EUR.MWH.H',
         'MARGINAL_COST.REFSDAL_G3.NO5.EUR.MWH.H',
         'MARGINAL_COST.REFSDAL_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.HOVE_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.HOVE_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_OVRE_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_OVRE_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_OVRE_G3.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G3.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G4.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G5.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G6.NO4.EUR.MWH.H',
         'MARGINAL_COST.INNSET_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.INNSET_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.LANGVATN_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.LANGVATN_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_1_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_1_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_1_G3.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_3_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_3_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.REPPA_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.VANGEN_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_2_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_2_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.AURLAND_2_G3.NO5.EUR.MWH.H',
         'MARGINAL_COST.GRESSLIFOSS_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEDRE_NEA_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.BRATSBERG_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.BRATSBERG_G2.NO3.EUR.MWH.H',
         'MARGINAL_COST.MONGSTAD.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_492.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_493.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_494.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_495.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_496.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_497.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_498.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_499.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_500.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_501.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_502.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_503.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_504.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_505.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_506.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_507.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_508.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_509.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_510.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_511.NO1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_512.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_513.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_514.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_515.NO2.EUR.MWH.H',
         'MARGINAL_COST.ALTA_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.ALTA_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ADAMSELV_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.ADAMSELV_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.STRAUMSMO_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.STRAUMSMO_G2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SVARTISEN_G1.NO4.EUR.MWH.H',
         'MARGINAL_COST.BJOLVO_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.BJOLVO_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5A_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5A_G2.NO3.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5A_G4.NO3.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5B_G3.NO3.EUR.MWH.H',
         'MARGINAL_COST.AROS3.SE3.EUR.MWH.H',
         'MARGINAL_COST.DALE_2_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_541.NO3.EUR.MWH.H',
         'MARGINAL_COST.TYIN_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.BORGUND_G2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NADDVIK_G1.NO1.EUR.MWH.H',
         'MARGINAL_COST.BLAFALLI_VIK_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.SONNA_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.SONNA_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_548.NO5.EUR.MWH.H',
         'MARGINAL_COST.MYSTER_G1.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_550.NO1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_551.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_552.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_553.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_554.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_555.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_556.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_557.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_558.SE3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_559.SE3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_560.SE4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_561.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_562.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_563.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_564.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_565.NO5.EUR.MWH.H',
         'MARGINAL_COST.MERIPORI_PVO.FIN.EUR.MWH.H',
         'MARGINAL_COST.INDUSTRY_BACK_1_FI.FIN.EUR.MWH.H',
         'MARGINAL_COST.INDUSTRY_BACK_2_FI.FIN.EUR.MWH.H',
         'MARGINAL_COST.KUUSAANNIEMI.FIN.EUR.MWH.H',
         'MARGINAL_COST.PIETARSAARI.FIN.EUR.MWH.H',
         'MARGINAL_COST.UIMAHARJU.FIN.EUR.MWH.H',
         'MARGINAL_COST.MALMO_CHP_G1.SE4.EUR.MWH.H',
         'MARGINAL_COST.MALMO_CHP_G2.SE4.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G1.NO2.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G3.NO2.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G4.NO2.EUR.MWH.H',
         'MARGINAL_COST.AVEDORE2_GAS.DK2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G1_X.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G2_X.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G3_X.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G4_X.NO2.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G1_X.NO5.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G2_X.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G1_X.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G2_X.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_592.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_593.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_594.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_595.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_596.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_597.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_598.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_599.SE3.EUR.MWH.H',
         'MARGINAL_COST.INDUSTRY_BACK_3_FI.FIN.EUR.MWH.H',
         'MARGINAL_COST.INDUSTRY_BACK_4_FI.FIN.EUR.MWH.H',
         'MARGINAL_COST.INDUSTRY_BACK_5_FI.FIN.EUR.MWH.H',
         'MARGINAL_COST.INDUSTRY_BACK_6_FI.FIN.EUR.MWH.H',
         'MARGINAL_COST.TONSTAD_G1_UNKNOWN.NO2.EUR.MWH.H',
         'MARGINAL_COST.TONSTAD_G2_UNKNOWN.NO2.EUR.MWH.H',
         'MARGINAL_COST.TONSTAD_G3_UNKNOWN.NO2.EUR.MWH.H',
         'MARGINAL_COST.TONSTAD_G4_UNKNOWN.NO2.EUR.MWH.H',
         'MARGINAL_COST.TONSTAD_G5_UNKNOWN.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_A3_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SAURDAL_A4_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G3_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G4_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYLEN_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYLEN_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.AURA_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G2_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G3_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G4_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G5_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G6_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.AURA_G7_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEA_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEA_G2_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEA_G3_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.GRYTTEN_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.OSBU_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.GRASJO_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.TROLLHEIM_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.SVORKA_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEDALSFOSS_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.TYA_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.VESSINGFOSS_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.KJELA_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SONGA_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.VINJE_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.VINJE_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.VINJE_G3_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G3_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.TOKKE_G4_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.BYRTE_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.LIO_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.JUKLA_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.MAURANGER_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.MAURANGER_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.TYSSO_2_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.TYSSO_2_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.OKSLA_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.MALSET_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.LEIRDOLA_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.JOSTEDAL_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.MAR_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G3_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G4_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.MAR_G5_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.RANA_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.RANA_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.RANA_G3_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.RANA_G4_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.BJERKA_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SVARTISEN_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.KOBBELV_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.KOBBELV_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.BATSVATN_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.NORDDALEN_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SKJOMEN_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SKJOMEN_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SKJOMEN_G3_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G3_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G4_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G5_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G6_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G7_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_1_G8_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.NORE_2_G1_STEP_2.NO1.EUR.MWH.H',
         'MARGINAL_COST.NORE_2_G2_STEP_2.NO1.EUR.MWH.H',
         'MARGINAL_COST.REFSDAL_G3_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.REFSDAL_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.HOVE_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.HOVE_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_OVRE_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_OVRE_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_OVRE_G3_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G3_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G4_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G5_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ROSSAGA_NEDRE_G6_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.INNSET_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.INNSET_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.LANGVATN_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.LANGVATN_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.GRESSLIFOSS_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.NEDRE_NEA_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.BRATSBERG_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.BRATSBERG_G2_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.ALTA_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ALTA_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ADAMSELV_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.ADAMSELV_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.STRAUMSMO_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.STRAUMSMO_G2_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.SVARTISEN_G1_STEP_2.NO4.EUR.MWH.H',
         'MARGINAL_COST.BJOLVO_G1_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.BJOLVO_G2_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5A_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5A_G2_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5A_G4_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.HOYANGER_K5B_G3_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G1_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G2_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G3_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.SIRA_KVINA_G4_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G1_X_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G2_X_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G3_X_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.KVILLDAL_G4_X_STEP_2.NO2.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G1_X_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.LANG_SIMA_G2_X_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G1_X_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.SY_SIMA_G2_X_STEP_2.NO5.EUR.MWH.H',
         'MARGINAL_COST.DECENTRAL_DK1_1.DK1.EUR.MWH.H',
         'MARGINAL_COST.DECENTRAL_DK1_2.DK1.EUR.MWH.H',
         'MARGINAL_COST.DECENTRAL_DK1_3.DK1.EUR.MWH.H',
         'MARGINAL_COST.DECENTRAL_DK2_1.DK2.EUR.MWH.H',
         'MARGINAL_COST.DECENTRAL_DK2_2.DK2.EUR.MWH.H',
         'MARGINAL_COST.DECENTRAL_DK2_3.DK2.EUR.MWH.H',
         'MARGINAL_COST.EIRIKSDAL_G1.NO3.EUR.MWH.H',
         'MARGINAL_COST.EIRIKSDAL_G2.NO3.EUR.MWH.H',
         'MARGINAL_COST.EIRIKSDAL_G1_STEP_2.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_747.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_748.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_749.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_750.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_751.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_752.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_753.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_754.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_755.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_756.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_757.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_758.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_759.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_760.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_761.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_762.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_763.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_764.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_765.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_766.NO1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_767.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_768.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_769.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_770.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_771.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_772.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_773.NO1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_774.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_775.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_776.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_777.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_778.NO4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_779.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_780.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_781.SE3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_782.SE3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_783.SE4.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_784.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_785.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_786.NO3.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_787.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_788.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_789.NO5.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_790.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_791.NO2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_792.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_793.SE2.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_794.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_795.SE1.EUR.MWH.H',
         'MARGINAL_COST.HYDRO_STATIONS_796.SE3.EUR.MWH.H']


def time_ssa_read_wrapper():
    wrapper = ReadWrapper(start_time='2015-01-01 00:00',
                          end_time='2020-12-31 23:00',
                          read_from=FameEnvironment(FAME_PREPROD_HOST, 'nordic_sim'))

    def f():
        wrapper.read(names, max_time_series_per_query=len(names))

    times = timeit.Timer(f).repeat(repeat=1, number=5)
    print(f'wrapper.read: {min(times) / 5} seconds')


def time_fame_api_read():
    db = fm.Db('nordic_sim', fm.RemoteConnect(7496, 7498, config.PREPROD_HOST))

    p = UtcPeriod(time('2015-01-01T00:00:00Z'), time('2020-12-31T23:00:00Z'))

    db.open(fm.OpenMode.READ, 1000)

    def f():
        db.read(names, p)

    times = timeit.Timer(f).repeat(repeat=1, number=5)
    print(f'db.read: {min(times) / 5} seconds')

    db.close()


def time_pyfame_batch_read():
    pyfame.initialize()

    _, connection_key = pyfame.open_connection(config.READ_SERVICE, config.PREPROD_HOST)

    _, db_key = pyfame.open_remote_database('nordic_sim', pyfame.DatabaseAccessMode.READ, connection_key)

    _, fame_range = pyfame.init_range(start=pyfame.FameTime(2015, 1, 1),
                                      end=pyfame.FameTime(2020, 12, 31, 23),
                                      frequency=pyfame.Frequency.HOURLY)

    def f():
        pyfame.batch_read_precisions(db_key, names, fame_range)

    times = timeit.Timer(f).repeat(repeat=1, number=5)
    print(f'pyfame.batch_read_precisions: {min(times) / 5} seconds')

    pyfame.finish()
